﻿using Styx;
using Styx.Common;
using Styx.CommonBot.Routines;
using Styx.TreeSharp;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Media;
#region [Method] - Class Redundancy
using HKM = Simplicity.Managers.Hotkey_Manager;
using R = Simplicity.Rotation.Rotation;
using D = Simplicity.Rotation.FeralDruid;
using U = Simplicity.Core.Unit;
#endregion  

namespace Simplicity
{

    public class Main: CombatRoutine
    {
        private static readonly Version version = new Version(0, 0, 1);
        public override string Name { get { return "Simplicity v." + version + "Developer Preview"; } }
        public override WoWClass Class { get { return WoWClass.Paladin; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }

        #region [Method] - Implementations
        private Composite _preCombatBehavior, _combatBuffBehavior, _combatBehavior;
        public override Composite PreCombatBuffBehavior { get { return _preCombatBehavior ?? (_preCombatBehavior = R.preCombatBuffing()); } }
        public override Composite CombatBuffBehavior { get { return _combatBuffBehavior ?? (_combatBuffBehavior = R.combatBuffing()); } }
        public override Composite CombatBehavior { get { return _combatBehavior ?? (_combatBehavior = R.rotationSelector()); } }

            #region [Method] - Hidden Overrides
            public override void Initialize()
            {
                Logging.Write(Colors.OrangeRed, "Hello {0}!", Me.Name);
                Logging.Write(Colors.White, "");
                Logging.Write(Colors.OrangeRed, "For optimal performance please use: Enyo");
                Logging.Write(Colors.White, "");
                Logging.Write(Colors.OrangeRed, "Current Version:");
                Logging.Write(Colors.OrangeRed, "Simplicity v." + version + " Developer Preview");
                Logging.Write(Colors.OrangeRed, "-- by theruss0n --");
                Logging.Write(Colors.OrangeRed, "-- A All-in-One Rotation --");
                HKM.registerHotKeys();
            }
            public override bool WantButton { get { return true; } }
            public override void OnButtonPress() { Logging.Write(Colors.OrangeRed, "Coming soon!"); }
            public override void ShutDown() { HKM.removeHotkeys(); }
            #endregion  
            #region [Method] - Pulse
            public override void Pulse()
            {
                if (!StyxWoW.IsInWorld || Me == null || !Me.IsValid || !Me.IsAlive)
                    return;
                if (!Me.Combat)
                    return;
                U.Cache();
                U.enemyAnnex(30);
            }
            #endregion  
        #endregion  


    }


}

